import Anchor from './components/anchor/Anchor'
import AnchorBox from './components/anchor/AnchorBox'
import ECharts from './components/echarts/ECharts'
import Highlight from './components/highlight/Highlight'
import Layout from './components/layout/Layout'
import SortButton from './components/sort-button/SortButton'
import SortButtonGroup from './components/sort-button/SortButtonGroup'
import Splitter from './components/splitter/Splitter'
import XList from './components/xlist/XList'
import XListItem from './components/xlist/XListItem'
import XMenu from './components/xmenu/XMenu'
import XMenuChildren from './components/xmenu/XMenuChildren'
import XMenuItem from './components/xmenu/XMenuItem'

import ellipsis from './directives/ellipsis'

import option from './components/option'

const components = [
  Anchor,
  AnchorBox,
  ECharts,
  Highlight,
  Layout,
  SortButton,
  SortButtonGroup,
  Splitter,
  XList,
  XListItem,
  XMenu,
  XMenuChildren,
  XMenuItem
]

const directives = {
  ellipsis
}

export default {
  install(Vue, defaultOption) {
    if (defaultOption) {
      option.echarts = defaultOption.echarts
    }
    // 注册指令
    for (let name in directives) {
      if (!directives.hasOwnProperty(name)) {
        continue
      }
      Vue.directive(name, directives[name])
    }

    // 注册组件
    for (let component of components) {
      Vue.component(component.name, component)
    }
  }
}

export {
  Anchor,
  AnchorBox,
  ECharts,
  ellipsis,
  Highlight,
  Layout,
  SortButton,
  SortButtonGroup,
  Splitter,
  XList,
  XListItem,
  XMenu,
  XMenuChildren,
  XMenuItem
}
